.386

.MODEL FLAT,STDCALL

OPTION CASEMAP:NONE

INCLUDE    \masm32\INCLUDE\windows.inc
INCLUDE    \masm32\INCLUDE\user32.inc
INCLUDE    \masm32\INCLUDE\kernel32.inc
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\kernel32.lib

WinMain PROTO :DWORD, :DWORD, :DWORD, :DWORD
DlgProc PROTO :HWND,  :DWORD, :DWORD, :DWORD

.DATA

ClassName  DB "SimpleWinClass",0
AppName    DB "Nasze okno gwne",0
MenuName   DB "FirstMenu",0
DlgName    DB "MyDialog",0
TestString DB "Cze wszystkim",0
hwndDlg    DD 0                   ; Uchwyt do okna dialogowego

.DATA?

hInstance   HINSTANCE ?
CommandLine LPSTR     ?

.CONST

IDM_EXIT   EQU    1
IDM_ABOUT  EQU    2
IDC_EDIT   EQU 3000
IDC_BUTTON EQU 3001
IDC_EXIT   EQU 3002

.CODE

start:
    INVOKE GetModuleHandle, NULL
    mov    hInstance, eax
    INVOKE GetCommandLine
    mov    CommandLine, eax
    INVOKE WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
    INVOKE ExitProcess, eax
	
WinMain PROC hInst:     HINSTANCE,\
             hPrevInst: HINSTANCE,\
             CmdLine:   LPSTR,\
             CmdShow:   DWORD

LOCAL wc:   WNDCLASSEX
LOCAL msg:  MSG
LOCAL hwnd: HWND

    mov    wc.cbSize, SIZEOF WNDCLASSEX
    mov    wc.style, CS_HREDRAW OR CS_VREDRAW
    mov    wc.lpfnWndProc, OFFSET WndProc
    mov    wc.cbClsExtra, NULL
    mov    wc.cbWndExtra, NULL
    push   hInst
    pop    wc.hInstance
    mov    wc.hbrBackground, COLOR_WINDOW+1
    mov    wc.lpszMenuName, OFFSET MenuName
    mov    wc.lpszClassName, OFFSET ClassName
    INVOKE LoadIcon, NULL, IDI_APPLICATION
    mov    wc.hIcon, eax
    mov    wc.hIconSm, eax
    INVOKE LoadCursor, NULL, IDC_ARROW
    mov    wc.hCursor, eax
    INVOKE RegisterClassEx, ADDR wc
    INVOKE CreateWindowEx, WS_EX_CLIENTEDGE,\
                           ADDR ClassName, ADDR AppName,\
                           WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,\
                           CW_USEDEFAULT, 300, 200, NULL, NULL,\
                           hInst, NULL
    mov    hwnd, eax
    INVOKE ShowWindow, hwnd, SW_SHOWNORMAL
    INVOKE UpdateWindow, hwnd

    .WHILE TRUE
        INVOKE GetMessage, ADDR msg, NULL, 0, 0
        .BREAK .IF (!eax)
        .IF hwndDlg!=0
            INVOKE IsDialogMessage, hwndDlg, ADDR msg
            .IF eax==TRUE
                .CONTINUE
            .ENDIF
        .ENDIF
        INVOKE TranslateMessage, ADDR msg
        INVOKE DispatchMessage, ADDR msg
    .ENDW

    mov eax, msg.wParam
    ret
	
WinMain ENDP

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    .IF uMsg==WM_DESTROY
        INVOKE PostQuitMessage, NULL
    .ELSEIF uMsg==WM_COMMAND
        .IF WORD PTR wParam==IDM_ABOUT
            INVOKE CreateDialogParam, hInstance,\
                                      ADDR DlgName, hWnd,\
                                      OFFSET DlgProc, NULL
            mov hwndDlg, eax
        .ELSE
            INVOKE DestroyWindow, hWnd
        .ENDIF
    .ELSE
        INVOKE DefWindowProc, hWnd, uMsg, wParam, lParam
        ret
    .ENDIF

    xor eax, eax
    ret

WndProc ENDP

DlgProc PROC hWnd:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM

    .IF iMsg==WM_INITDIALOG
        INVOKE GetDlgItem, hWnd, IDC_EDIT
        INVOKE SetFocus, eax
    .ELSEIF iMsg==WM_CLOSE
        INVOKE EndDialog, hWnd, NULL
        mov hwndDlg, 0
    .ELSEIF iMsg==WM_COMMAND
        mov ax, WORD PTR wParam
        .IF WORD PTR wParam+2==BN_CLICKED
            .IF ax==IDC_EXIT
                INVOKE SendMessage, hWnd, WM_CLOSE, NULL, NULL
            .ELSEIF ax==IDC_BUTTON
                INVOKE SetDlgItemText, hWnd, IDC_EDIT, ADDR TestString
            .ENDIF
        .ENDIF		   
    .ELSE
        mov eax, FALSE
        ret
    .ENDIF
    mov  eax, TRUE
    ret

DlgProc ENDP

END start
